package cn.ibizlab.businesscentral.core.odoo_sale.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_sale.domain.Sale_order;
import cn.ibizlab.businesscentral.core.odoo_sale.filter.Sale_orderSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Sale_orderMapper extends BaseMapper<Sale_order>{

    Page<Sale_order> searchDefault(IPage page, @Param("srf") Sale_orderSearchContext context, @Param("ew") Wrapper<Sale_order> wrapper) ;
    @Override
    Sale_order selectById(Serializable id);
    @Override
    int insert(Sale_order entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Sale_order entity);
    @Override
    int update(@Param(Constants.ENTITY) Sale_order entity, @Param("ew") Wrapper<Sale_order> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Sale_order> selectByAnalyticAccountId(@Param("id") Serializable id) ;

    List<Sale_order> selectByFiscalPositionId(@Param("id") Serializable id) ;

    List<Sale_order> selectByIncoterm(@Param("id") Serializable id) ;

    List<Sale_order> selectByPaymentTermId(@Param("id") Serializable id) ;

    List<Sale_order> selectByOpportunityId(@Param("id") Serializable id) ;

    List<Sale_order> selectByTeamId(@Param("id") Serializable id) ;

    List<Sale_order> selectByPricelistId(@Param("id") Serializable id) ;

    List<Sale_order> selectByCompanyId(@Param("id") Serializable id) ;

    List<Sale_order> selectByPartnerId(@Param("id") Serializable id) ;

    List<Sale_order> selectByPartnerInvoiceId(@Param("id") Serializable id) ;

    List<Sale_order> selectByPartnerShippingId(@Param("id") Serializable id) ;

    List<Sale_order> selectByCreateUid(@Param("id") Serializable id) ;

    List<Sale_order> selectByUserId(@Param("id") Serializable id) ;

    List<Sale_order> selectByWriteUid(@Param("id") Serializable id) ;

    List<Sale_order> selectBySaleOrderTemplateId(@Param("id") Serializable id) ;

    List<Sale_order> selectByWarehouseId(@Param("id") Serializable id) ;

    List<Sale_order> selectByCampaignId(@Param("id") Serializable id) ;

    List<Sale_order> selectByMediumId(@Param("id") Serializable id) ;

    List<Sale_order> selectBySourceId(@Param("id") Serializable id) ;


}
